{.po0}
{.pl71}
{$R-}
{$C-}
{$U-}
{$V-}
{$X+}
PROGRAM TurboBBS;
(*******************************************************************)
(*                                                                 *)
(*  PRK-84 Turbo Bulletin Board System L{hdekoodin p{{tiedosto.    *)
(*                                                                 *)
(* (( (c) 1985 by Robert H. Maxwell                                *)
(*              201 - 2275 West 7th Avenue,                        *)
(*              Vancouver, British Columbia, CANADA                *)
(*              V6K 1Y3 ))                                         *)
(*                                                                 *)
(*  PRK-84:lle sovittanut Antti Rantanen, Runkotie 9, 01730 Vantaa *)
(*  Finland p. 358-(9)0-892340                                     *)
(*                                                                 *)
(*  Ohjelma on PD-ohjelma, joten sen kaupallinen hy|dynt{minen on  *)
(*  ANKARASTI KIELLETTY !!!!!                                      *)
(*                                                                 *)
(*  Ohjelma on yritetty tehd{ mahdollisimman luotettavaksi, mutta  *)
(*  mahdollisista virheist{ ja niiden mahdollisesti aiheuttamista  *)
(*  vahingoista ei(v{t) tekij{(t) ota mit{{n vastuuta.             *)
(*                                                                 *)
(*  Tarvittavat tiedostot k{{nn|saikana:                           *)
(*                              BBS.PAS     (t{m{ tiedosto)        *)
(*                              BBS2.INC    (aliohjelmat)          *)
(*                              MACHDEP.INC (koneriippuvat osat)   *)
(*                              IO.INC      (I/O -rutiinit)        *)
(*                              MAILSYS.INC (viestienk{sittely)    *)
(*                                                                 *)
(*  Ohjelma vaatii seuraavat informaatiotiedostot:                 *)
(*                             BBSINFO.LBR (j{senet listattu alla) *)
(*                                                                 *)
(*  Ohjelma synnytt{{ itse seuraavat tiedostot:                    *)
(*                              MESSAGES.BBS (Viestitaulut)        *)
(*                              FILES.BBS    (Tiedostotaulu)       *)
(*  N{m{ tulisi tuhota sil-  -> COMMENTS.BBS (Kommentit SYSOP:lle) *)
(*  loin t{ll|in..kasvavat.. -> LOG.BBS      (soittop{iv{kirja)    *)
(*  ..nopeasti.                 IDS.BBS      (k{ytt{j{lista)       *)
(*                                                                 *)
(*  .TXT tyyppiset tiedostot ovat muotoiltavissa WordStar:lla.     *)
(*  .BBS tyyppiset tiedostot yll{pit{{ ohjelma itse.               *)
(*  SYSOP-nimiselle k{ytt{j{lle annetaan j{rjestelm{ss{ automaat-  *)
(*  tisesti SYSOP:n oikeudet (vain salasana vaaditaan)             *)
(*                                                                 *)
(*******************************************************************)
LABEL from_files;
CONST
  version   = '1.06 TA alphatronic PC:lle';
  sectsin = True;  (* Osasto-ominaisuus pois/p{{lle. *)
  openBBS = True;  (* Valinta: yksityinen/yleinen j{rjestelm{. *)
  messdrive = 'A:';  (* Viestit menev{t levylle A: *)
  filedrive = 'B:';  (* Tiedostot ovat levyll{ B: *)

  sysop   = 5;  (* K{ytt|oikeustasot. *)
  reg     = 2;
  newuser = 1;
  twit    = 0;
  noecho    = False;
  echo      = True;
  null      = ^@;     (* ASCII-merkkej{ *)
  abort     = ^C;
  bell      = ^G;
  bksp      = ^H;
  tab       = ^I;
  lnfd      = ^J;
  cr        = ^M;
  pause     = ^S;
  esc       = ^[;
  space     = ' ';
  numsects = 12;    (* Osastojen lukum{{r{ tiedostoj{rjestelm{ss{. *)

  maxlength = 24;
  maxlenstr = '24';
  maxmess = 127;   (* <-- Maximum number of messages - this limit due to CP/M
                     maximum directory size on PRK-84.*)

TYPE
  name      = STRING[ 14 ];
  longname  = STRING[ 25 ];
  filbuffer = ARRAY[ 0..127 ] OF Byte;
  line      = STRING[ 80 ];
  person    = STRING[ 27 ];
  long      = STRING[ 150 ];
  sysid     = RECORD              (* Systeemin tila. *)
                user: person;     (* Nimi *)
                exfl: Byte;       (* Lippu: onko h{ipynyt ilmoittanatta ? *)
                lsto: longname;   (* Aika: milloin viimeksi vieraillut ?  *)
                lstm: Integer;    (* Viimeisen viestin numero             *)
                pass: name;       (* Salasana *)
                acc:  Byte;       (* K{ytt|oikeustaso *)
                clr:  name;       (* Ruuduntyhjennysmerkkijono *)
                bsp:  Char;       (* ASCII BackSpace:a vastaava merkki *)
                lnf:  Char;       (* ASCII LineFeed:a vastaava merkki. *)
                upc:  Boolean;    (* Vain isot kirjaimet -lippu *)
                wid:  Byte;       (* N{yt|n leveys merkkein{. *)
              END;
  log       = RECORD              (* Lokitietue. *)
                who:  Integer;    (* K{ytt{j{numero. *)
                when: longname;   (* Koska tullut -p{iv{ys. *)
                done: longname;   (* Koska l{htenyt p{iv{ys. *)
              END;
  yesno     = ARRAY[  Boolean ] OF STRING[ 5 ];
  messages = RECORD  (* Tiedot viestist{. *)
              number:  Integer;     (* Numero.    *)
              sender:  Integer;     (* L{hett{j{. *)
              recver:  Integer;     (* Vastaanottaja. *)
              subject: name;        (* Aihe. *)
              date:    longname;    (* P{iv{ys. *)
              private: Boolean;     (* Lippu: yksityinen/yleinen *)
              section: Byte;        (* Osasto. *)
              repto:   Integer;
              reply:   Integer;
              recved:  Boolean;
            END;
  sectname = ARRAY[ 1..numsects ] OF STRING[ 20 ];
  messtext = array[ 1..maxlength ] of line;
  monthname = STRING[ 10 ];
  monames  = ARRAY[ 1..12 ] OF monthname;


var
  libfile    : FILE;
  libbuff    : filbuffer;
  libeof     : Boolean;
  logfile    : FILE OF log;
  logrec     : log;
  idfile     : FILE OF sysid;
  idrec      : sysid;
  caller     : person;
  password,
  cs,
  message    : name;
  timeon,
  timeoff    : longname;
  buffer     : long;
  cancelled  : Boolean;
  inbuffer   : line;
  hou,min,sec,
  access     : Byte;
  libsects,
  usernum,
  lastmess,
  nextmess,
  charcount,
  lastspace,
  bufpointer,
  width,
  Rounder    : Integer;
  Timest     : String[8];
  controls,
  printon,             (* Kaikki merkit my|s Lst tiedostoon ? *)
  local,               (* Konsoli komentaa, jos local. *)
  filesopen,
  messopen,
  caps,                    (* Vain isot kirjaimet. *)
  expert     : Boolean;     (* Kokeneen k{ytt{j{n moodi ? *)
  thisdate   : string[25];
  exitchar,
  bl, lf, bs : Char; (* Merkkimuuttujia *)

  messagefile: file of messages;
  count      : integer;
  messtable  : array[ 1..maxmess ] of messages;
  preformat  : boolean;

  FILEPRGRM : FILE;  (* OVERLAY-OHJELMA B:BBSFILES.CHN = TIEDOSTO-OHJELMA.*)

  (*************************************************************************)
  (* Muuttujavakioiden m{{rittelyt. GLOBAALEJA !!!!!!                      *)
  (*************************************************************************)

  CONST
  sect : sectname = ('1: Yleist{',
                     '2: Tiedonsiirto',
                     '3: CP/M PD',
                     '4: Ostetaan/myyd{{n',
                     '5: Ongelmat',
                     '6: Turbo Pascal',
                     '7: C-kieli',
                     '8: Modemit',
                     '9: Printterit',
                     '10: 6502-Assembler',
                     '11: Z80-Assembler',
                     '12: TurboBBS koodi');

  yn: yesno = ('EI','KYLL['); (* False ja True suomen kielell{. *)

 {$IA:MACHDEP.INC}
 {$IA:IOFSYS.INC}
 {$IA:MAILSYS.INC}
 {$IA:BBS2.INC}
BEGIN  (* P{{ohjelma alkaa t{st{ *)
  IF Mem[ $80 ] = $FF THEN
   GOTO from_files;
  exitchar := space;
  local := False;
  resetbuff;
  setup;
  defaults;
  awaitcall;
  WHILE exitchar <> abort DO
   BEGIN
    flush;
    resetbuff;
    lineout('TurboBBS versio ' + version);
    IF cts AND NOT cancelled THEN TYPEFILE('B:WELCOME.TXT',false);
    IF cts AND NOT cancelled THEN TYPEFILE('B:BULLETIN.TXT',false);
    IF cts THEN signon(caller);
    IF cts THEN initmess;
    readmine;              (* TARKISTAA CTS:n itse *)
from_files: (* T{h{n palataan tiedostoj{rjestelm{st{ *)
    IF cts THEN command;
    Writeln('Puhelu on p{{ttynyt...');
    endcall;
    IF messopen THEN closemess;
    Close(idfile);
    defaults;
    awaitcall
   END
END.
N closemess;
    Close(idfile);
    defaults;
    awaitcall
   END
END.
