{.po0}
{.pl72}
{$R-}
{$C-}
{$V-}
{$U-}
{$X+}
PROGRAM filesys( Input, Output, Aux );

(****************************************************************************)
(* T{st{ alkaa ohjelman BBS.PAS kanssa yhteisten GLOBAALIEN muuttujien m{{- *)
(* rittelyt.                                                                *)
(****************************************************************************)

CONST
  version   = '1.06 TA alphatronic PC:lle';
  sectsin = True;  (* Osasto-ominaisuus pois/p{{lle. *)
  openBBS = True;  (* Valinta: yksityinen/yleinen j{rjestelm{. *)
  messdrive = 'A:';  (* Viestit menev{t levylle A: *)
  filedrive = 'B:';  (* Tiedostot ovat levyll{ B: *)

  sysop   = 5;  (* K{ytt|oikeustasot. *)
  reg     = 2;
  newuser = 1;
  twit    = 0;
  noecho    = False;
  echo      = True;
  null      = ^@;     (* ASCII-merkkej{ *)
  abort     = ^C;
  bell      = ^G;
  bksp      = ^H;
  tab       = ^I;
  lnfd      = ^J;
  cr        = ^M;
  pause     = ^S;
  esc       = ^[;
  space     = ' ';
  numsects = 12;    (* Osastojen lukum{{r{ tiedostoj{rjestelm{ss{. *)

  maxlength = 24;
  maxlenstr = '24';
  maxmess = 127;   (* <-- Maximum number of messages - this limit due to CP/M
                     maximum directory size on PRK-84.*)

TYPE
  name      = STRING[ 14 ];
  longname  = STRING[ 25 ];
  filbuffer = ARRAY[ 0..127 ] OF Byte;
  line      = STRING[ 80 ];
  person    = STRING[ 27 ];
  long      = STRING[ 150 ];
  sysid     = RECORD              (* Systeemin tila. *)
                user: person;     (* Nimi *)
                exfl: Byte;       (* Lippu: onko h{ipynyt ilmoittanatta ? *)
                lsto: longname;   (* Aika: milloin viimeksi vieraillut ?  *)
                lstm: Integer;    (* Viimeisen viestin numero             *)
                pass: name;       (* Salasana *)
                acc:  Byte;       (* K{ytt|oikeustaso *)
                clr:  name;       (* Ruuduntyhjennysmerkkijono *)
                bsp:  Char;       (* ASCII BackSpace:a vastaava merkki *)
                lnf:  Char;       (* ASCII LineFeed:a vastaava merkki. *)
                upc:  Boolean;    (* Vain isot kirjaimet -lippu *)
                wid:  Byte;       (* N{yt|n leveys merkkein{. *)
              END;
  log       = RECORD              (* Lokitietue. *)
                who:  Integer;    (* K{ytt{j{numero. *)
                when: longname;   (* Koska tullut -p{iv{ys. *)
                done: longname;   (* Koska l{htenyt p{iv{ys. *)
              END;
  yesno     = ARRAY[  Boolean ] OF STRING[ 5 ];
  messages = RECORD  (* Tiedot viestist{. *)
              number:  Integer;     (* Numero.    *)
              sender:  Integer;     (* L{hett{j{. *)
              recver:  Integer;     (* Vastaanottaja. *)
              subject: name;        (* Aihe. *)
              date:    longname;    (* P{iv{ys. *)
              private: Boolean;     (* Lippu: yksityinen/yleinen *)
              section: Byte;        (* Osasto. *)
              repto:   Integer;
              reply:   Integer;
              recved:  Boolean;
            END;
  sectname = ARRAY[ 1..numsects ] OF STRING[ 20 ];
  messtext = array[ 1..maxlength ] of line;
  monthname = STRING[ 10 ];
  monames  = ARRAY[ 1..12 ] OF monthname;


var
  libfile    : FILE;
  libbuff    : filbuffer;
  libeof     : Boolean;
  logfile    : FILE OF log;
  logrec     : log;
  idfile     : FILE OF sysid;
  idrec      : sysid;
  caller     : person;
  password,
  cs,
  message    : name;
  timeon,
  timeoff    : longname;
  buffer     : long;
  cancelled  : Boolean;
  inbuffer   : line;
  hou,min,sec,
  access     : Byte;
  libsects,
  usernum,
  lastmess,
  nextmess,
  charcount,
  lastspace,
  bufpointer,
  width,
  Rounder    : Integer;
  Timest     : String[8];
  controls,
  printon,             (* Kaikki merkit my|s Lst tiedostoon ? *)
  local,               (* Konsoli komentaa, jos local. *)
  filesopen,
  messopen,
  caps,                    (* Vain isot kirjaimet. *)
  expert     : Boolean;     (* Kokeneen k{ytt{j{n moodi ? *)
  thisdate   : string[25];
  exitchar,
  bl, lf, bs : Char; (* Merkkimuuttujia *)

  messagefile: file of messages;
  count      : integer;
  messtable  : array[ 1..maxmess ] of messages;
  preformat  : boolean;

  MAINPRGRM : FILE;  (* OVERLAY-OHJELMA B:BBSFILES.CHN = TIEDOSTO-OHJELMA.*)

  (*************************************************************************)
  (* Muuttujavakioiden m{{rittelyt. GLOBAALEJA !!!!!!                      *)
  (*************************************************************************)

  CONST
  sect : sectname = ('1: Yleist{',
                     '2: Tiedonsiirto',
                     '3: CP/M PD',
                     '4: Ostetaan/myyd{{n',
                     '5: Ongelmat',
                     '6: Turbo Pascal',
                     '7: C-kieli',
                     '8: Modemit',
                     '9: Printterit',
                     '10: 6502-Assembler',
                     '11: Z80-Assembler',
                     '12: TurboBBS koodi');

  yn: yesno = ('EI','KYLL['); (* False ja True suomen kielell{. *)


(******************** BBSFILES.PAS -ohjelman paikalliset muuttujat **********)
  const
    mostfiles = 110;  (* Maksimim{{r{ tiedostoja systeemiss{ (levy B:) *)
    soh = 1;          (* ASCII: otsikon alku *)
    eot = 4;          (* ASCII: siirron loppu *)
    ack = 6;          (* ASCII: kuittaus *)
    nak = $15;        (* ASCII: negatiivinen kuittaus *)
    can = $18;        (* ASCII: peruutus *)
    C = $43;          (* CTRL-C:n vaihtoehto = 'C' *)
    drivecap = 250;   (* Levytila kilotavuina tiedosto-osastoja varten. *)
    ksize = 2;        (* Tiedoston koon minimikasvu kilotavuina = CP/M:n *)
                      (* BLOCK SHIFT *)
  type
    filerec = RECORD  (* TIEDOSTOTIETUE *)
               title: name;
               submit: Integer;
               date: longname;
               size: Integer;
               accesses: Integer;
               ASCII: Boolean;
               section: Byte;
               public: Boolean
              END;

    channel = ARRAY[ 0..127 ] OF Byte;
var
    filefile: FILE OF filerec;
    filetab: ARRAY[ 0..mostfiles ] OF filerec;
    filebuff: ARRAY [ 0..16 ] OF channel;
    datafile: FILE;
    chksum: Byte;
    CRC: Integer;
    crcmode: Boolean;
    enddir: Integer;
    comch:  Char;

 {$IA:MACHDEP.INC}
 {$IA:IOFSYS.INC}
 {$IA:BBSXMODM.INC}
 {$IA:BBSFSYS.INC}

  BEGIN
    initfile;
    IF NOT expert THEN typefile('B:FILEMENU.TXT',true);
    REPEAT
      lineout(space);
      comch := getcap('Tiedostokomento ("?"=menu) : ');
      CASE comch OF
       'D' : directory;
       'S' : transmitfile;
       'T' : textdump;
       'H' : typefile('B:FILEHLP.TXT',true);
       'G' : disconnect;
       '?' : typefile('B:FILEMENU.TXT',true);
       'L' : ldir;
       'U' : IF access>newuser THEN BEGIN crcmode := True; newfile(true); END;
       'C' : IF access>newuser THEN BEGIN crcmode := False; newfile(true); END;
       'V' : IF access>newuser THEN newfile(false);
       'K' : IF access = sysop THEN killfile;
       'I' : IF access = sysop THEN installfile;
       'E' : IF access = sysop THEN editheader;
       'Q' : BEGIN
              Clearsc;
              IF cts THEN lineout('Suljen tiedostoj{rjestelm{n... ');
              closefile;
              IF cts THEN lineout('K{ynnist{n j{lleen postilaatikon... ');
              Assign(MAINPRGRM,'A:BBS.COM');
              {$I-} Execute(MAINPRGRM); {$I+}
              IF IOresult <> 0 THEN
               IF cts THEN
                lineout(^M^J'En l|yd{ p{{ohjelmaa A:BBS.COM => et p{{se'+
                        ' takaisin postilaatikkoon.'^M^J);
             END
      END (* CASE-lause *)
    UNTIL NOT cts;
    Writeln('Suljen tiedostoj{rjestelm{n...');
    closefile;
    savedefaults;
    Writeln('K{ynnist{n j{lleen postilaatikon... ');
    Assign(MAINPRGRM,'A:BBS.COM');
    {$I-} Execute(MAINPRGRM); {$I+}
    IF IOresult <> 0 THEN
     Writeln(^M^J'En l|yd{ p{{ohjelmaa A:BBS.COM => et p{{se takaisin',
             ' postilaatikkoon.'^M^J);
  END.ikkoon.'^M^J);
  END.